package com.example.ueberwachungssystem;

import static java.lang.Boolean.TRUE;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.hardware.SensorEvent;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ToggleButton;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    private Logger logger;
    private Context context;
    private Accelerometer beschleunigungssensor;
    //private ThreadDemo threadDemo;
    private TextView textViewLog;
    private Button button1;
    private TextView textViewWorkerThread;
    SensorEvent event;

    ToggleButton toggleButton1;

    boolean currentAlarm;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setTitle(this.getClass().getSimpleName());
        setContentView(R.layout.activity_main);

        // Logger setup
        textViewLog = (TextView) findViewById(R.id.textViewLog);
        logger = new Logger(this.getClass().getSimpleName(), textViewLog, "");

        toggleButton1 = (ToggleButton) findViewById(R.id.toggleButton1); //togglebutton um Thread zu steuern
        toggleButton1.setOnClickListener(this);
        textViewWorkerThread = (TextView) findViewById(R.id.textViewWorkerThread); //TextView um Thread zu überwachen
        textViewWorkerThread.setMovementMethod(new ScrollingMovementMethod());

        //Button to clear Log while Debugging
        button1 = (Button) findViewById(R.id.button1);
        button1.setOnClickListener(this);

        //Accelerometer Setup
        beschleunigungssensor = new Accelerometer(this, logger, textViewWorkerThread);
        beschleunigungssensor.getSensor();

        logger.log("onCreate");
    }

    @Override
    protected void onResume() {
        super.onResume();
    }
    @Override
    protected void onPause() {
        super.onPause();
        beschleunigungssensor.stopDetection();
    }

    @Override
    public void onClick(View v) {
        logger.log("toggleButton1 is clicked");
        if(v == toggleButton1) {
            if (toggleButton1.isChecked()) {
                logger.log("ToggleButton is ON");
                beschleunigungssensor.startDetection();
                logger.log("Detection started");

            } else {
                logger.log("ToggleButton is OFF");
                beschleunigungssensor.stopDetection();
                logger.log("Detection stopped");
            }
        } else if (v == button1) {
            logger.clearLog();
        }
    }
}